#! /usr/bin/env python

import json

from matplotlib import pyplot as plt

def getTotalCost(earnings="Yearly"):
    total = 0

    clients = parseJson()["accounting"]["clients"]
    for client in clients:
        plan_cost = client["Cost"]

        if client["Subscription"] == "Monthly":
            total = total + (plan_cost * 12)
        elif client ["Subscription"] == "Yearly":
            total = total + plan_cost
        else:
            print("Error: Subscription must be either 'Yearly' or 'Monthly'")

    if earnings == "Monthly":
        total = total / 12
        return total

    return total

def generateBarChart():
    users = []
    yearly_income = []
    
    clients = parseJson()["accounting"]["clients"]
    for client in clients:
        client_name = client["Name"]
        plan_cost = client["Cost"]

        users.append(client_name)

        if client["Subscription"] == "Monthly":
           yearly_income.append(plan_cost * 12)
        elif client ["Subscription"] == "Yearly":
            yearly_income.append(plan_cost)

    plt.bar(users, yearly_income, color ='blue',
            width = 0.4)
    
    plt.title("Yearly income generated by Client")
    plt.xlabel("Client Name")
    plt.ylabel("Yearly Income ($)")
    plt.savefig('income_by_client_chart.png')
    
def parseJson(file_path="clients.json"):
    json_file = open(file_path)
    clients = json.load(json_file)
    return clients